// #autoload
// #name = CapperAlert
// #category = ilys' Scripts
// #config = CapperAlertGUI

$CapperAlert::Message = "Begin flag run!";
if(isFile("prefs/CapperAlertPrefs.cs")) exec("prefs/CapperAlertPrefs.cs");

package CapperAlert
{
	function PlayGui::onWake( %this )
	{
		parent::onWake( %this );
		if(!isObject(PlayGui)) return;
		if(isObject(CapperAlertHud))
		{
			schedule(150, 0, RefreshCapperHud);
			return;
		}
		new GuiControlProfile("CapperAlertHudTextProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 27;
			fontColor = "255 0 0";
			justify = "center";
		};
		%x = strlen($CapperAlert::Message)*11;
		new ShellFieldCtrl(CapperAlertHud)
		{
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = getword($pref::Video::resolution, 0)/2-(%x/2) @ " " @ getword($pref::Video::resolution, 1)/4;
			extent = %x@" 26";
			minExtent = "8 8";
			visible = "0";
			new GuiMLTextCtrl(CapperAlertHudtext)
			{
				profile = "CapperAlertHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = %x@" 26";
				visible = "1";
			};
		};
		playGui.add(CapperAlertHud);
		CapperAlertHud.setVisible(false);
		CapperAlertHudtext.setValue($CapperAlert::Message);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(CapperAlertHud,"CapperAlert");
	}

	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		if(strStr(%msgString, "SpammerAlert:") != -1)
		{
			alxPlay(InputDeniedSound, 0, 0, 0);
			CapperAlertHud.setVisible(true);
			CapperAlertHud.schedule(3000, setVisible, false);
		}
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	function quit()
	{
		export("$CapperAlert::*", "prefs/CapperAlertPrefs.cs", false);
		parent::quit();
	}

	function DisconnectedCleanup()
	{
		CapperAlertHud.setVisible(false);
		parent::DisconnectedCleanup();
	}

	function RefreshCapperHud()
	{
		%x = strlen($CapperAlert::Message)*11;
		CapperAlertHud.position = getword($pref::Video::resolution, 0)/2-(%x/2) @ " " @ getword($pref::Video::resolution, 1)/4;
		CapperAlertHud.extent = %x@" 26";
		CapperAlertHudtext.setValue($CapperAlert::Message);
		CapperAlertHudtext.extent = %x@" 26";
	}
};
activatePackage(CapperAlert);

new GuiControl(CapperAlertGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "130 75";
	minExtent = "130 75";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "center";
		vertSizing = "bottom";
		position = "0 0";
		extent = "130 75";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "15 10";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Capper Message";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "10 25";
			extent = "135 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$CapperAlert::Message";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
	};
};
